
// example presented in paragraph 7.9 of the manual
// https://maniFEM.rd.ciencias.ulisboa.pt/manual-maniFEM.pdf
// a skew torus made of two triangular patches

#include "maniFEM.h"

using namespace maniFEM;


int main ( )

{	// begin with the usual two-dimensional space
	Manifold RR2 ( tag::Euclid, tag::of_dim, 2 );
	Function xy = RR2 .build_coordinate_system ( tag::Lagrange, tag::of_degree, 1 );
	Function x = xy[0], y = xy[1];

	// define two actions on RR2 (translations)
	Manifold::Action g1 ( tag::transforms, xy, tag::into, (x+1.) && y ),
	                 g2 ( tag::transforms, xy, tag::into, (x+0.5) && (y+0.866) );

	// and divide RR2 by the group of translations generated by {g1,g2}
	Manifold torus_manif = RR2 .quotient ( g1, g2 );

	// one vertex is enough to start the process
	Cell A ( tag::vertex );  x(A) = 0. ;  y(A) = 0.;

	// with this vertex, we build three segments
	Mesh seg_horiz = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( A ) .stop_at ( A ) .divided_in ( 10 ) .winding ( g1 );
	Mesh seg1 = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( A ) .stop_at ( A ) .divided_in ( 10 ) .winding ( g2 );
	Mesh seg2 = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( A ) .stop_at ( A ) .divided_in ( 10 ) .winding ( g2 - g1 );

	Mesh tri1 = Mesh::Build ( tag::grid ) .shape ( tag::triangle )
		.faces ( seg_horiz, seg2, seg1 .reverse() ) .winding();
	Mesh tri2 = Mesh::Build ( tag::grid ) .shape ( tag::triangle )
		.faces ( seg_horiz .reverse(), seg2 .reverse(), seg1 ) .winding();

	Mesh torus = Mesh::Build ( tag::join ) .meshes ( { tri1, tri2 } );

	std::vector < Cell > vec;
	Mesh::Iterator it = torus .iterator ( tag::over_cells, tag::of_dim, 2, tag::around, A );
	for ( it .reset(); it .in_range(); it++ )  vec .push_back ( *it );
	std::vector < Cell > ::iterator itv;
	for ( itv = vec .begin(); itv != vec .end(); itv++ )
	{	Cell sq = *itv;  sq .remove_from ( torus );  }

	// we can draw an unfolded mesh
	torus .export_to_file ( tag::eps, "torus.eps", tag::unfold,
	                        tag::over_region, -1.6 < x < 1.7, -1.3 < y < 1.3 );
	std::cout << "produced file torus.eps - please edit before viewing" << std::endl;

}  // end of main
